--satchel charge script v1 by iii 2013

visual=true--can be changed to false for less workload
radius={}--start 30
visualimg={}
lastexplode={}
satchellist={}--{x={},y={},rot={}} in pixel

addhook("spawn","satchel_spawn")
function satchel_spawn(id)
radius[id]=30
lastexplode[id]=false
spawn_first_satchel(id)
return ""
end

function spawn_first_satchel(id)
parse("spawnprojectile "..id.." 89 -1000 -1000 0 0")
end

addhook("projectile","satchel_projectile")
function satchel_projectile(id,wep,x,y)
if wep==89 then
	if not lastexplode[id] then
		lastexplode[id]=true
		reqcld(id,2)
		timer(300,"setlastexplode",tostring(id))
	end
end
end

function setlastexplode(stringid)
id=tonumber(stringid)
lastexplode[id]=false
end

addhook("clientdata","satchel_clientdata")
function satchel_clientdata(id,mode,x,y)
if mode==2 then
	satchellist[id]=save_satchel(id,x,y)
	timer(20,"respawn_satchel",tostring(id))
else
	imagepos(visualimg[id],x,y,0)
end
end

function save_satchel(id,x,y)
local list={x={},y={},rot={}}
for _,p in pairs(projectilelist(1,id)) do
	if projectile(p.id,p.player,"x")~=-1000 and projectile(p.id,p.player,"y")~=-1000 then
		if projectile(p.id,p.player,"type")==89 and radiusdis(x,y,p,id) then
			list.x[#list.x+1]=projectile(p.id,p.player,"x")
			list.y[#list.y+1]=projectile(p.id,p.player,"y")
			list.rot[#list.rot+1]=projectile(p.id,p.player,"rot")
			parse("freeprojectile "..p.id.." "..id)
		end
	end
end
return list
end

function radiusdis(x,y,p,id)
if math.sqrt((projectile(p.id,p.player,"x")-x)^2+(projectile(p.id,p.player,"y")-y)^2)<=radius[id] or radius[id]==0 then
return false else return true end 
end

function respawn_satchel(stringid)
id=tonumber(stringid)
spawn_first_satchel(id)
for splace=1,#satchellist[id].x do
	parse("spawnprojectile "..id.." 89 "..satchellist[id].x[splace].." "..satchellist[id].y[splace].." 0 "..satchellist[id].rot[splace])
end
table.remove(satchellist[id])
end

addhook("startround_prespawn","satchel_startround_prespawn")
function satchel_startround_prespawn(mode)
satchellist={}
end

addhook("select","satchel_select")
function satchel_select(id,wep,mode)
if wep==89 then
	if radius[id]==0 then
		if visualimg[id]~=nil then
		freeimage(visualimg[id])
		visualimg[id]=nil
		end
	else
		if visualimg[id]==nil then
			visualimg[id]=image("gfx/sprites/wave.bmp",10,10,2,id)
			imagescale(visualimg[id],radius[id]/16,radius[id]/16)
			imageblend(visualimg[id],1)
		else
			freeimage(visualimg[id])
			visualimg[id]=nil
			visualimg[id]=image("gfx/sprites/wave.bmp",10,10,2,id)
			imagescale(visualimg[id],radius[id]/16,radius[id]/16)
			imageblend(visualimg[id],1)
		end
	end
else
	if visualimg[id]~=nil then
		freeimage(visualimg[id])
		visualimg[id]=nil
	end
end
end

addhook("always","satchel_always")
function satchel_always()
for _,id in pairs(player(0,"tableliving")) do
	if visualimg[id]~=nil then
		reqcld(id,0)
	end
end
end

addhook("die","satchel_die")
function satchel_die(id)
if visualimg[id]~=nil then
freeimage(visualimg[id])
visualimg[id]=nil
end
end

addhook("serveraction","satchel_serveraction")
function satchel_serveraction(id,key)
if key==3 then
	if radius[id]==30 then
		radius[id]=70
		msg2(id,"radius is 70")
	elseif radius[id]==70 then
		radius[id]=0
		msg2(id,"radius is deactivate")
	elseif radius[id]==0 then
		radius[id]=30
		msg2(id,"radius is 30")
	end
	if player(id,"weapontype")==89 and visual then
		if radius[id]==0 then
			if visualimg[id]~=nil then
				freeimage(visualimg[id])
				visualimg[id]=nil
			end
		else
			if visualimg[id]~=nil then
				imagescale(visualimg[id],radius[id]/16,radius[id]/16)
			else
				visualimg[id]=image("gfx/sprites/wave.bmp",10,10,2,id)
				imagescale(visualimg[id],radius[id]/16,radius[id]/16)
				imageblend(visualimg[id],1)
			end
		end
	end
end
end

if visual==false then
freehook("always","satchel_always")
freehook("select","satchel_select")
freehook("die","satchel_die")
end