--satchel charge script v2 by iii 2013

visual=true--can be changed to false for less workload
radius={}--start 30
visualimg={}
satchellist={}--{x,y,img} in pixel

addhook("spawn","satchel_spawn")
function satchel_spawn(id)
for _,p in pairs(projectilelist(1,id)) do
	if projectile(p.id,p.player,"type")==89 then			
		parse("freeprojectile "..p.id.." "..id)				
	end
end
satchellist[id]={x={},y={},img={}}
radius[id]=30
spawn_first_satchel(id)
return ""
end

function spawn_first_satchel(id)
parse("spawnprojectile "..id.." 89 -1000 -1000 0 0")
end

addhook("projectile","satchel_projectile")
function satchel_projectile(id,wep,x,y)
if wep==89 then
	spawn_first_satchel(id)
	reqcld(id,2)
end
end

addhook("clientdata","satchel_clientdata")
function satchel_clientdata(id,mode,x,y)
if mode==2 then
	for b,_ in pairs(satchellist[id].x) do
		if math.sqrt((satchellist[id].x[b]-x)^2+(satchellist[id].y[b]-y)^2)<=radius[id] or radius[id]==0 then
			freeimage(satchellist[id].img[b])
			parse("explosion "..satchellist[id].x[b].." "..satchellist[id].y[b].." 150 "..itemtype(89,"dmg").." "..id)
			satchellist[id].x[b]=-1000
			satchellist[id].y[b]=-1000
			satchellist[id].img[b]=1
		end
	end
else
	imagepos(visualimg[id],x,y,0)
end
end

addhook("leave","satchel_leave")
function satchel_leave(id,reason)
satchellist[id]={}
end

addhook("ms100","satchel_ms100")
function satchel_ms100()
	for _,id in pairs(player(0,"tableliving")) do
		for _,p in pairs(projectilelist(1,id)) do
			if projectile(p.id,p.player,"type")==89 and projectile(p.id,p.player,"x")~=-1000 and projectile(p.id,p.player,"y")~=-1000 then			
				satchellist[id].x[#satchellist[id].x+1]=projectile(p.id,p.player,"x")
				satchellist[id].y[#satchellist[id].y+1]=projectile(p.id,p.player,"y")
				satchellist[id].img[#satchellist[id].img+1]=image("gfx/weapons/satchelcharge.bmp<m>",satchellist[id].x[#satchellist[id].x],satchellist[id].y[#satchellist[id].y],0)
				imagepos(satchellist[id].img[#satchellist[id].img],satchellist[id].x[#satchellist[id].x],satchellist[id].y[#satchellist[id].y],projectile(p.id,p.player,"rot"))
				parse("freeprojectile "..p.id.." "..id)				
			end
		end
	end
end

addhook("startround_prespawn","satchel_startround_prespawn")
function satchel_startround_prespawn(mode)
satchellist={}
end

addhook("select","satchel_select")
function satchel_select(id,wep,mode)
if wep==89 then
	if radius[id]==0 then
		if visualimg[id]~=nil then
		freeimage(visualimg[id])
		visualimg[id]=nil
		end
	else
		if visualimg[id]==nil then
			visualimg[id]=image("gfx/sprites/wave.bmp",10,10,2,id)
			imagescale(visualimg[id],radius[id]/16,radius[id]/16)
			imageblend(visualimg[id],1)
		else
			freeimage(visualimg[id])
			visualimg[id]=nil
			visualimg[id]=image("gfx/sprites/wave.bmp",10,10,2,id)
			imagescale(visualimg[id],radius[id]/16,radius[id]/16)
			imageblend(visualimg[id],1)
		end
	end
else
	if visualimg[id]~=nil then
		freeimage(visualimg[id])
		visualimg[id]=nil
	end
end
end

addhook("hit","satchel_hit")
function satchel_hit(id,src,wep,hp,ar,raw)
if wep==251 and player(id,"health")-hp<=0 then
parse('customkill '..src..' "Satchel Charge" '..id)
return 1
end
end

addhook("always","satchel_always")
function satchel_always()
for _,id in pairs(player(0,"tableliving")) do
	if visualimg[id]~=nil then
		reqcld(id,0)
	end
end
end

addhook("die","satchel_die")
function satchel_die(id)
if visualimg[id]~=nil then
freeimage(visualimg[id])
visualimg[id]=nil
end
for b=1,#satchellist[id].x do
freeimage(satchellist[id].img[1])
table.remove(satchellist[id].x,1)
table.remove(satchellist[id].y,1)
table.remove(satchellist[id].img,1)
end
end

addhook("serveraction","satchel_serveraction")
function satchel_serveraction(id,key)
if key==3 then
	if radius[id]==30 then
		radius[id]=70
		msg2(id,"radius is 70")
	elseif radius[id]==70 then
		radius[id]=0
		msg2(id,"radius is deactivate")
	elseif radius[id]==0 then
		radius[id]=30
		msg2(id,"radius is 30")
	end
	if player(id,"weapontype")==89 and visual then
		if radius[id]==0 then
			if visualimg[id]~=nil then
				freeimage(visualimg[id])
				visualimg[id]=nil
			end
		else
			if visualimg[id]~=nil then
				imagescale(visualimg[id],radius[id]/16,radius[id]/16)
			else
				visualimg[id]=image("gfx/sprites/wave.bmp",10,10,2,id)
				imagescale(visualimg[id],radius[id]/16,radius[id]/16)
				imageblend(visualimg[id],1)
			end
		end
	end
end
end

if visual==false then
freehook("always","satchel_always")
freehook("select","satchel_select")
end